import { ActionType, IComponentSchemaJson, IListenerInstance, IMaterialItem, IWebRuntimeAppData, IExtraData, IDynamicValue, IWeAppComponentInstance, IComponentLibEntry } from '../../weapps-core';
import { BuildType, IComponentsInfoMap, IFileCodeMap } from '../types/common';
import { Schema } from '@formily/react-schema-renderer';
import { DEPLOY_MODE, RUNTIME } from '../../types';
import { IPlatformApp } from '@cloudbase/cals';
export declare function runGenerateCore(props: {
    appBuildDir: string;
    cals: IPlatformApp;
    appData: IWebRuntimeAppData;
    subAppDataList: IWebRuntimeAppData[];
    dependencies: IMaterialItem[];
    appKey: string;
    buildTypeList: BuildType[];
    basename: string;
    deployOptions: {
        mode: DEPLOY_MODE;
        version?: string;
    };
    runtime: RUNTIME;
    ignoreInstall: boolean;
    extraData: {
        isComposite: boolean;
        compProps: any;
    };
    i18nConfig: any;
    fileCodeMap: IFileCodeMap;
    isSandbox: boolean;
    _indexPage: boolean;
    processCssUnit?: 'px' | 'rpx' | 'rem';
    rpxCalcRoot?: string;
    isPrivateMode?: boolean;
}): Promise<void>;
export interface IOriginKeyInfo {
    sourceKey: string;
    name: string;
    materialName: string;
    materialVersion: string;
    key: string;
    variableName: string;
    type?: ActionType;
    isComposite?: boolean;
    isPlainProps?: boolean;
    entries?: IComponentLibEntry;
}
export declare function getOriginComponentAndActionList(componentSchema: IComponentSchemaJson, dependencies: IMaterialItem[], originComponentList?: IOriginKeyInfo[], originActionList?: IOriginKeyInfo[], genericCompMap?: Record<string, IWeAppComponentInstance['genericComp']>): {
    originComponentList: IOriginKeyInfo[];
    originActionList: IOriginKeyInfo[];
};
export declare function pullActionToListByInstances(listenerInstances: any, originActionList: any, fixedDependencies: IFixedDependence[]): void;
interface IFixedDependence extends IMaterialItem {
    isPlainProps?: boolean;
    entries?: IComponentLibEntry;
}
export declare function pullComponentToListByInstance(sourceKey: string, originComponentList: IOriginKeyInfo[], fixedDependencies: IFixedDependence[]): void;
export declare function isSlot(comp: Schema): boolean | "" | undefined;
export declare function getComponentSchemaString(componentSchema: IComponentSchemaJson, isComposite?: boolean, componentsInfoMap?: IComponentsInfoMap, wrapperClass?: string, processCssUnit?: 'rpx' | 'rem' | 'px', rpxCalcRoot?: string): {
    widgets: string;
    dataBinds: string;
    componentSchema: string;
};
export declare function generateDataBind(bind: IDynamicValue): string;
export declare function getListenersString(listeners?: IListenerInstance[], isComposite?: boolean): string;
export declare function generateRouterFile(allAppDataList: IWebRuntimeAppData[], appBuildDir: string, basename: string | undefined, buildTypeList: BuildType[] | undefined, fileCodeMap: IFileCodeMap, isSandbox: any, _indexPage?: boolean): Promise<void>;
export declare function generateAppData(cals: any, dependencies: any, appBuildDir: any, deployOptions: any, fileCodeMap: IFileCodeMap): Promise<void>;
export declare function writeLowCodeFiles(appData: IWebRuntimeAppData, appBuildDir: string, fileCodeMap: IFileCodeMap, rootPath: string, processCssUnit: any, rpxCalcRoot: any): Promise<void>;
export declare function generateCodeFromTpl(
/**
 * 应用ID
 */
appKey: string, 
/**
 * 应用数据
 */
appData: IWebRuntimeAppData, appBuildDir: string, rootPath: string, extraData: IExtraData, i18nConfig: any, fileCodeMap: IFileCodeMap, isSandbox: boolean, subAppDataList: IWebRuntimeAppData[], buildTypeList: BuildType[], deployOptions: {
    mode: DEPLOY_MODE;
    version?: string;
}, 
/**
 * 静态域名
 */
domain: string, dependencies: any, processCssUnit: any, isPrivateMode: boolean): Promise<void>;
export declare function generateFilesFromTemplate({ templatesData, fileCodeMap, baseTargetPath, }: {
    templatesData: {
        [key: string]: Object;
    };
    fileCodeMap?: {
        [filePath: string]: {
            code: string;
        };
    };
    baseTargetPath?: string;
}): {
    [filePath: string]: {
        code: string;
    };
};
export {};
